%def_without test
%define java_home /usr/lib/j2se
%define _javadir /usr/share/java

Name: jboss
License: LGPL
Group: Development/Java
Version: 4.0.5.GA
Release: alt2
Summary: A Very Popular Java Application Server
Url: http://jboss.org/developers/projects/jboss
Source0: %name-%version-src.tar.gz
Source1: jboss
Source2: sysconfig.jboss
Source3: jboss.logrotate
BuildArch: noarch

Requires: j2se1.5-sun-devel
BuildRequires: j2se1.5-sun j2se1.5-sun-devel ant xalan-j xerces-j junit sax

%description
JBoss is a fully-featured Open source Java application server. It
includes support for J2EE-based APIs.

JBoss is used in production in everything from single CPU Linux/Windows
deployments to very high-end E15K, hunderd of CPU, Solaris cluster
boxes.

JBoss leads the way in automation and enterprise readliness with
features such as hot-deply, modular design, unified class loaders,
dynamic proxies and no compilation. On the security front, BEA followed
our lead on the JAAS integration. We continue to lead BEA with our JMX
support, as well as in-memory transaction processing.


%package docs
Group: Development/Java
Summary: Configuration files for JBoss AS
Requires: jboss

%description docs
JBoss documentation

%package client
Group: Development/Java
Summary: Configuration files for JBoss AS
Requires: jboss

%description client
Client libraries for JBoss

%package config-all
Group: Development/Java
Summary: Configuration files for JBoss AS
Requires: jboss

%description config-all
Full configuration for JBoss

%package config-default
Group: Development/Java
Summary: Configuration files for JBoss AS
Requires: jboss

%description config-default
Default configuration for JBoss

%package config-minimal
Group: Development/Java
Summary: Configuration files for JBoss AS
Requires: jboss

%description config-minimal
Minimal configuration for JBoss


%prep
%setup -q -n %name-%version-src

%build
. /usr/lib/java-common/java-functions
AddToClasspath junit.jar xalan-j.jar xerces-j.jar xml-common-apis.jar
AddToClasspath jaxp_parser_impl.jar jaxp_transform_impl.jar sax.jar
FindJVM

cd build
install -m 644 etc/local.properties-production local.properties
echo "build.compiler=modern"   >> local.properties
# The following applies to at least Java 1.3.x versions:
echo "build.sysclasspath=last" >> local.properties
sh ./build.sh -Dbuild.id=%version-%release

%install
# Remove unused files
%__rm -f build/output/%name-%version/bin/{jboss_init_*.sh,*.bat,run.conf}

%__install -m 755 -d $RPM_BUILD_ROOT%_sysconfdir/%name
%__install -m 755 -d $RPM_BUILD_ROOT%_cachedir/%name
%__install -m 755 -d $RPM_BUILD_ROOT%_logdir/%name
%__install -m 755 -d $RPM_BUILD_ROOT%_localstatedir/%name
%__install -m 755 -d $RPM_BUILD_ROOT%_datadir/%name

%__cp -a build/output/%name-%version/{bin,lib} $RPM_BUILD_ROOT%_datadir/%name
%__cp -a build/output/%name-%version/client $RPM_BUILD_ROOT%_datadir/%name-client
%__cp -a build/output/%name-%version/server $RPM_BUILD_ROOT%_localstatedir/%name
ln -sf %_localstatedir/%name/server $RPM_BUILD_ROOT%_datadir/%name/

for conf in all default minimal ; do
	mv $RPM_BUILD_ROOT%_localstatedir/%name/server/$conf/conf $RPM_BUILD_ROOT%_sysconfdir/%name/$conf
	ln -sf ../../../../..%_sysconfdir/%name/$conf $RPM_BUILD_ROOT%_localstatedir/%name/server/$conf/conf

	install -m 755 -d $RPM_BUILD_ROOT%_logdir/%name/$conf
	ln -sf ../../../../log/%name/$conf $RPM_BUILD_ROOT%_localstatedir/%name/server/$conf/log

	install -m 700 -d $RPM_BUILD_ROOT%_cachedir/%name/$conf
	ln -sf ../../../../cache/%name/$conf $RPM_BUILD_ROOT%_localstatedir/%name/server/$conf/work
done

# documentation
%__mkdir_p documentation/{aop,cluster,connector,server,ejb3,iiop,jboss.net,jmx,naming,security,server,system,webservice}
%__cp -a aop/docs/* documentation/aop/
%__cp -a cluster/docs/* cluster/src/examples documentation/cluster/
%__cp -a connector/src/resources/dtd documentation/connector/
%__cp -a docbook-support documentation/
%__cp -a ejb3/docs/* ejb3/src/resources/schema documentation/ejb3/
%__cp -a iiop/src/resources/* documentation/iiop/
%__cp -a jmx/src/resources/dtd documentation/jmx/
%__cp -a naming/src/docs/* documentation/naming/
%__cp -a security/docs/* security/src/resources/dtd documentation/security/
%__cp -a server/src/docs/* server/src/resources/{dtd,schema} documentation/server/
%__cp -a system/src/resources/dtd documentation/system/
#__cp -a webservice/README* webservice/src/resources/{dtd,schema} documentation/webservice/


# init script and sysconfig
install -m 755 -D %SOURCE1 $RPM_BUILD_ROOT%_initdir/%name
install -m 644 -D %SOURCE2 $RPM_BUILD_ROOT%_sysconfdir/sysconfig/%name
install -m 744 -D %SOURCE3 $RPM_BUILD_ROOT%_sysconfdir/cron.daily/jboss

# do tests if it is enabled
%if_with test
	sh ./build/build.sh run-jboss >/dev/null &
	sleep 60
	sh ./build/build.sh run-testsuite
	./build/output/%name-%version/bin/shutdown.sh -S
	cp -a testsuite/output/reports/html $RPM_BUILD_ROOT/%_datadir/%name/docs/tests
%endif

%pre
# the old version of the server must be stopped before it is updated
# it will not be restarted because the configuration has been most
# probably changed and it is not garanted that the new version
# will work with the old configuration
[ -e %_initdir/%name ] && %_initdir/%name stop > /dev/null || true
/usr/sbin/useradd -r -c "JBoss - Java Application Server" \
	-s /dev/null -d %_datadir/%name %name 2>/dev/null || :


%post
if [ $1 = 0 ]; then
	%_initdir/%name condrestart
fi

%preun
if [ $1 = 0 ]; then
	/sbin/chkconfig --del %name
	%_initdir/%name condstop
fi


%files
%defattr(-, root, root)
%config %_initdir/%name
%config %_sysconfdir/sysconfig/%name
%config %_sysconfdir/cron.daily/%name
%dir %_sysconfdir/%name
%dir %_localstatedir/%name
%dir %_cachedir/%name
%dir %_logdir/%name
%_datadir/%name/bin
%_datadir/%name/lib
%_datadir/%name/server
%dir %_localstatedir/%name/server

%files docs
%doc documentation/*

%files client
%_datadir/%name-client

%files config-all
%defattr(-, jboss, jboss)
%dir %_localstatedir/%name/server/all
%_localstatedir/%name/server/all/conf
%_localstatedir/%name/server/all/work
%_localstatedir/%name/server/all/log
%_localstatedir/%name/server/all/lib
%config(noreplace) %_sysconfdir/%name/all
%config(noreplace) %_localstatedir/%name/server/all/deploy
%config(noreplace) %_localstatedir/%name/server/all/deploy-hasingleton
%config(noreplace) %_localstatedir/%name/server/all/farm
%dir %_logdir/%name/all
%dir %_cachedir/%name/all

%files config-default
%defattr(-, jboss, jboss)
%dir %_localstatedir/%name/server/default
%_localstatedir/%name/server/default/conf
%_localstatedir/%name/server/default/work
%_localstatedir/%name/server/default/log
%_localstatedir/%name/server/default/lib
%config(noreplace) %_sysconfdir/%name/default
%config(noreplace) %_localstatedir/%name/server/default/deploy
%dir %_logdir/%name/default
%dir %_cachedir/%name/default

%files config-minimal
%defattr(-, jboss, jboss)
%dir %_localstatedir/%name/server/minimal
%_localstatedir/%name/server/minimal/conf
%_localstatedir/%name/server/minimal/work
%_localstatedir/%name/server/minimal/log
%_localstatedir/%name/server/minimal/lib
%config(noreplace) %_sysconfdir/%name/minimal
%config(noreplace) %_localstatedir/%name/server/minimal/deploy
%dir %_logdir/%name/minimal
%dir %_cachedir/%name/minimal


%changelog
* Wed Apr 11 2007 Igor Muratov <migor@altlinux.org> 4.0.5.GA-alt2
- bug 11452 fixed

* Fri Nov 10 2006 Igor Muratov <migor@altlinux.org> 4.0.5.GA-alt1
- new version

* Thu Oct 12 2006 Igor Muratov <migor@altlinux.org> 4.0.4.GA-alt2
- rebuild vith java 1.5

* Fri Jun  3 2006 Igor Muratov <migor@altlinux.org> 4.0.4.GA-alt1
- new version

* Fri Jun  2 2006 Igor Muratov <migor@altlinux.org> 4.0.3SP1-alt6
- split to few packages
- spec cleanup

* Mon Apr 17 2006 Igor Muratov <migor@altlinux.org> 4.0.3SP1-alt5
- fix dependences
- fix sysconfig.jboss example

* Thu Apr 13 2006 Igor Muratov <migor@altlinux.org> 4.0.3SP1-alt4
- fix for locale settings

* Wed Mar 29 2006 Igor Muratov <migor@altlinux.org> 4.0.3SP1-alt3
- fix soft links

* Mon Mar 27 2006 Igor Muratov <migor@altlinux.org> 4.0.3SP1-alt2
- rebuild with noarch

* Thu Mar 09 2006 Igor Muratov <migor@altlinux.org> 4.0.3SP1-alt1
- new version

* Thu Aug 25 2005 Igor Muratov <migor@altlinux.org> 4.0.2-alt1
- new version

* Fri Mar  4 2005 Igor Muratov <migor@altlinux.org> 4.0.1sp1-alt1
- First build for ALT.
